//------------------------------------------------------------------
//------------------------------------------------------------------+
#property indicator_separate_window
#property indicator_buffers 1 
#property indicator_color1  PaleVioletRed
#property indicator_width1     2
#property indicator_maximum    0
#property indicator_minimum -100 
#property indicator_level1   -20
#property indicator_level2   -80

extern int    WprPeriod    = 32;
extern double MinimalRange = 10;
double wpr[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,wpr); 
   return(0);
}
int deinit() { return(0); }
int start()
{
   int i,counted_bars=IndicatorCounted();
     if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   double filter = MinimalRange*Point; if (Digits==3 || Digits==5) filter *= 10.0;
   for(i = limit; i >= 0; i--)
   {
       double hhv  = High[iHighest(NULL, 0, MODE_HIGH, WprPeriod, i)];
       double llv  = Low[iLowest (NULL, 0, MODE_LOW,  WprPeriod, i)]; 
       if (hhv!=llv && (High[i]-Low[i])>=filter)
            wpr[i] = -100*(hhv-Close[i])/(hhv-llv);
       else wpr[i] = wpr[i+1];          
   } 
   return(0);
}

